clear
%Rechtecksignal bipolar 1V duty 50%
%Anzahl der Samples 1000 duty 50%
t=1:1:1000
time=0:(2/1000):2-1/1000
s2=(1)*sign(t)
s1=(-1)*sign(t(1:length(t)/4))
s2(1:length(t)/4)=s1(1:length(t)/4)
s2(length(t)/2+1:(length(t)/2+length(t)/4))=s1(1:length(t)/4)
%noise ueff=1V
n = -1/1.41 + (2/1.41).*rand(1,1000)
s=s2+n
figure(1)
plot(time,s)
axis([0 max(time) -2 2])
title('Rechtecksignal')
xlabel('t in ms')
ylabel('Amplitude')
%*********************************
%*      Histogramm (WDF)         *
%*********************************
%Auflsung des Histogramms dy=0.01
x=min(s):0.01:max(s)
%Histogramm erzeugen
h=hist(s,x)/length(s)
%Plot WDF
figure(2)
subplot(2,2,2)
plot(x,h)
title('Histogramm')
xlabel('Amplitude')
ylabel('Auftretenswahrsch.')
%*********************************
%*     Amplitudenverteilung      *
%*********************************
%f(x)=Integral(histogramm,0,x)
temp=0
for i=1:length(h)
   temp(1:length(temp))=0 
   temp(1:i)=h(1:i)
   y(i)=sum(temp)        %Integral von 0 bis i
end
%Reskallierung auf 1 (Verteilung kann nur zwischen f(-inf)=0 und f(+inf)=1
%liegen
y=y./max(y)
%Plot Verteilungsfunktion
subplot(2,2,4)
plot(x,y)
title('Verteilungsfunktion')
xlabel('Amplitude')
ylabel('Verteilung')
%*********************************
%*     Autokorrelationsfkt.      *
%*********************************
[Rss,tau]=xcorr(s,s)
Rss=Rss/length(s)
time_shift=(-2+1/1000):2/1000:(2-2/1000)
subplot(2,2,1)
plot(time_shift,Rss)
axis([-max(time) max(time) -1.5 1.5])
title('Autokorrelationsfunktion')
xlabel('\tau in ms')
ylabel('Rxx(Tau)')
%*********************************
%*    Kreuzkorrelationsfkt.      *
%*********************************
[Rsn,tau]=xcorr(s2,n)
Rsn=Rsn/length(s)
subplot(2,2,3)
time_shift=(-2+1/1000):2/1000:(2-2/1000)
plot(time_shift,Rsn)
title('Kreuzkorrelationsfunktion')
xlabel('\tau in ms')
ylabel('Rsn(Tau)')
axis([-max(time) max(time) 0 1])

